'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var defaultState = function defaultState() {
    return {
        visible: false,
        locked: false,
        yesBtnText: 'Yes',
        noBtnText: 'No'
    };
};

var Notie = function (_Component) {
    _inherits(Notie, _Component);

    function Notie(props) {
        _classCallCheck(this, Notie);

        var _this = _possibleConstructorReturn(this, (Notie.__proto__ || Object.getPrototypeOf(Notie)).call(this, props));

        _initialiseProps.call(_this);

        _this.state = Object.assign({
            message: '',
            level: 'INFO'
        }, defaultState());
        return _this;
    }

    _createClass(Notie, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.root.style.opacity = 0;
        }
    }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps, nextState) {
            return this.state.visible !== nextState.visible || this.props.position !== nextProps.position;
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (this.transitionendCallback) {
                this.root.removeEventListener('transitionend', this.transitionendCallback);
                this.transitionendCallback = null;
            }

            if (this.timeout) {
                clearTimeout(this.timeout);
                this.timeout = null;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                message = _state.message,
                level = _state.level,
                visible = _state.visible;

            var classes = (0, _classnames2.default)('react-notie', 'react-notie--' + this.props.position.toLowerCase(), 'react-notie-level--' + level.toLowerCase(), {
                'react-notie--active': visible
            });

            return _react2.default.createElement(
                'div',
                { ref: this.rootRef, className: classes },
                level === 'CONFIRM' && visible && _react2.default.createElement('div', { className: 'react-notie-overlay' }),
                _react2.default.createElement(
                    'div',
                    { className: 'react-notie-container' },
                    _react2.default.createElement(
                        'div',
                        { className: 'react-notie-message' },
                        message
                    ),
                    level === 'CONFIRM' && _react2.default.createElement(
                        'div',
                        { className: 'react-notie-choices' },
                        _react2.default.createElement(
                            'div',
                            { className: 'react-notie-choice react-notie-choice--yes', onClick: this.handleYes },
                            this.state.yesBtnText
                        ),
                        _react2.default.createElement(
                            'div',
                            { className: 'react-notie-choice react-notie-choice--no', onClick: this.handleNo },
                            this.state.noBtnText
                        )
                    ),
                    level !== 'CONFIRM' && _react2.default.createElement('div', { className: 'react-notie-dismiss', onClick: this.handleDismiss })
                )
            );
        }
    }]);

    return Notie;
}(_react.Component);

Notie.defaultProps = {
    ttl: 5000,
    position: 'top'
};
Notie.propTypes = {
    ttl: _propTypes2.default.number,
    position: _propTypes2.default.oneOf(['top', 'bottom'])
};

var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.alert = function () {
        var settings = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        if (_this2.state.locked) return;

        var toLock = settings.level === 'CONFIRM';

        if (_this2.timeout) {
            clearTimeout(_this2.timeout);
            _this2.timeout = null;
        }

        if (_this2.state.visible) {
            _this2.hide(function () {
                return _this2.alert(settings);
            });
            return;
        }

        _this2.root.style.opacity = 1;

        _this2.setState(function (state) {
            return {
                message: settings.message,
                level: settings.level,
                visible: true,
                locked: toLock,
                yesBtnText: settings.yesBtnText || state.yesBtnText,
                noBtnText: settings.noBtnText || state.noBtnText
            };
        });

        if (!toLock) {
            _this2.timeout = setTimeout(function () {
                _this2.hide();
                _this2.timeout = null;
            }, settings.ttl || _this2.props.ttl);
        }
    };

    this.confirm = function (message, props) {
        _this2.alert(Object.assign({}, props, { message, level: 'CONFIRM' }));

        return new Promise(function (resolve, reject) {
            _this2.confirmResolve = resolve;
            _this2.confirmReject = reject;
        });
    };

    this.success = function (message, ttl) {
        _this2.alert({ message, level: 'SUCCESS', ttl });
    };

    this.error = function (message, ttl) {
        _this2.alert({ message, level: 'ERROR', ttl });
    };

    this.warn = function (message, ttl) {
        _this2.alert({ message, level: 'WARN', ttl });
    };

    this.info = function (message, ttl) {
        _this2.alert({ message, level: 'INFO', ttl });
    };

    this.hide = function (callback) {
        _this2.setState(function () {
            return defaultState();
        });
        _this2.transitionendCallback = function () {
            _this2.root.style.opacity = 0;
            if (typeof callback === 'function') callback();
            _this2.root.removeEventListener('transitionend', _this2.transitionendCallback);
            _this2.transitionendCallback = null;
        };
        _this2.root.addEventListener('transitionend', _this2.transitionendCallback);
    };

    this.handleYes = function () {
        return _this2.hide(_this2.confirmResolve);
    };

    this.handleNo = function () {
        return _this2.hide(_this2.confirmReject);
    };

    this.handleDismiss = function () {
        if (_this2.timeout) {
            clearTimeout(_this2.timeout);
            _this2.timeout = null;
        }

        if (_this2.state.visible) {
            _this2.hide();
        }
    };

    this.rootRef = function (c) {
        return _this2.root = c;
    };
};

exports.default = Notie;